import processing.serial.*;

Serial myPort;  // Create object from Serial class
String val = "";     // Data received from the serial port
float previousval = 0;
float m;

PFont verdana;
PFont verdana12;
PFont verdana48;

void setup()
{
  printArray(Serial.list()); // print in console the Serial list
  delay(1000);  // And wait one second
  String portName = Serial.list()[5]; //In my case the serial is the n 5
  myPort = new Serial(this, portName, 9600);
  delay(100);

  size(400, 400);
  verdana12 = createFont("Verdana", 12);
  verdana = createFont("Verdana", 32);
  verdana48 = createFont("Verdana", 48);
  textFont(verdana);
}

void draw()
{
  if ( myPort.available() > 0)
  {  // If data is available,
    val = myPort.readStringUntil('\n');         // read it and store it in val
    println(val); //print it out in the console
  } else {
    println("No Data"); //print it out in the console
  }
  colorMode(RGB);
  background(0);
  fill(255);
  textAlign(CENTER);
  textFont(verdana);
  text("Temperature Monitor", width/2, 40);
  textFont(verdana48);
  text(val, width/2, 90);
  textFont(verdana);
  text("ºC", 310, 90);

  if (previousval > float(val)) {   // temperature variation
    fill(0, 0, 255);
    text("<", 360, 380);
  } else if (previousval < float(val)) {
    fill(255, 0, 0);
    text(">", 360, 380);
  } else {
    fill(255);
    text("=", 360, 380);
  }
  textFont(verdana12);
  text("Temp \nvariation", 310, 365);

  fill(255);
  text( hour() + ":" + minute(), 30, 370); // current time
  
  rect(180, 120, 40, 200);  // draw thermometer
  
  colorMode(HSB, 360, 100, 100);  // Change mode color to HSB
  m = map(float(val), 10, 34, 0, 200);  // Min temp 25ºC to 34º and get the height of rectangle
  float H_color = map(float(val), 10, 34, 220, 0); // Min temp 25ºC to 34º and get the component H of color (from blue to red)
   fill(H_color, 80, 80); // Fill with current color 
  rect(180, 320, 40, -m); // draw rectangle
  previousval=float(val); // store previous temperature for compare
  delay(500);
}
